#Ce script prend en argument un fichier .xml sorti du script script_TT_S2.pl
#et un fichier .txt contenant des patrons morphosyntaxiques a extraire, un patron par ligne.
#Il donne en sortie autant de fichiers .txt qu'il y avait des patrons.
#Chaque fichier de sortie contient des patrons extraits du fichier .xml fourni, un patron par ligne. 
#---------------------------------------------------------------------------
#/usr/bin/perl
use Unicode::String qw(utf8);

my $filein=$ARGV[0];
my $filepatt=$ARGV[1];

open (FILEPATT,"<:encoding(UTF-8)", "$filepatt");
my @patterns;

while ($linepatt=<FILEPATT>){
	print $linepatt;
	chomp($linepatt);
	push(@patterns,$linepatt);
	
}
close (FILEPATT);
#$nb_patterns=$#patterns+1;
#print "$nb_patterns $linepatt\n";


my $nombrepatterns=$#patterns+1;
my $compteurpatterns=0;

while ($compteurpatterns<$nombrepatterns){
	open (FILEIN,"<:encoding(UTF-8)", "$filein");
	my @tokens=split(/ /,$patterns[$compteurpatterns]);
	my $nombretokens=$#tokens+1;
	print "pattern: $pattern  nombretokens: $nombretokens\n";
	my $pattern2=join("_", @tokens);
	print "pattern2: $pattern2\n";

	my $fileout=$filein.$pattern2.".txt";
	print "fileout: $fileout\n";
	open (FILEOUT,">>:encoding(UTF-8)", "$fileout");

	my @motifs=();
	my $nombremotifs=0;
	my $rien=0;
	
	while ($rien==0){
		my $i=0;
		while ($i<$nombretokens){
				
				$line=<FILEIN>;
													if ($line=~/<\/contenu>/){goto label_end;}
				#print "tokens[$i]: $tokens[$i] ";
							
				if ($line=~/<data type="type">$tokens[$i]([^<]*)<\/data>/){
					$line=<FILEIN>;
													
					$line=<FILEIN>;
													
					$line=~/<data type="string">([^<]+)<\/data>/;
					my $mot=$1;
					print "mot: $mot\n";
					push(@motifs,$mot);
					$nombremotifs=$#motifs+1;
					#print "nombremotifs: $nombremotifs\n";
					$line=<FILEIN>;
													if ($line=~/<\/contenu>/){goto label_end;}
					$line=<FILEIN>;
													if ($line=~/<\/contenu>/){goto label_end;}
					
				}
				
				elsif ($line=~/<data type="type">$tokens[0]([^<]*)<\/data>/){
					$line=<FILEIN>;
													
					$line=<FILEIN>;
													
					$line=~/<data type="string">([^<]+)<\/data>/;
					my $mot=$1;
					@motifs=();
					push(@motifs,$mot);
					$nombremotifs=$#motifs+1;
					$i=0;
					$line=<FILEIN>;
													if ($line=~/<\/contenu>/){goto label_end;}
					$line=<FILEIN>;
													if ($line=~/<\/contenu>/){goto label_end;}
					
				}
				
			$i++;
		}
		#print "nombremotifs2: $nombremotifs\n";
		if ($nombremotifs==$nombretokens){
			foreach my $motifchik (@motifs){
				print FILEOUT "$motifchik ";
				#print "motifchik: $motifchik";
			}
			print FILEOUT "\n";
			#print "\n";
			
		}
	@motifs=();
	$nombremotifs=0;
	
	}
	label_end:
	

close(FILEOUT);
$compteurpatterns++;
}

close(FILEIN);